Loading...
Searching...
No Matches
Opm::FluidStateExplicitCompositionModule< Scalar, FluidSystem, Implementation > Class Template Reference

Module for the modular fluid state which stores the phase compositions explicitly in terms of mole fractions. More...

`#include <FluidStateCompositionModules.hpp>`

## Public Member Functions

const Scalar & | moleFraction (unsigned phaseIdx, unsigned compIdx) const
| The mole fraction of a component in a phase [].
const Scalar & | moleFraction (unsigned compIdx) const
| The total mole fraction of a component [].
Scalar | massFraction (unsigned phaseIdx, unsigned compIdx) const
| The mass fraction of a component in a phase [].
const Scalar & | averageMolarMass (unsigned phaseIdx) const
| The mean molar mass of a fluid phase [kg/mol].
Scalar | molarity (unsigned phaseIdx, unsigned compIdx) const
| The concentration of a component in a phase [mol/m^3].
void | setMoleFraction (unsigned phaseIdx, unsigned compIdx, const Scalar &value)
| Set the mole fraction of a component in a phase [] and update the average molar mass [kg/mol] according to the current composition of the phase.
void | setMoleFraction (unsigned compIdx, const Scalar &value)
| Set the total mole fraction of a component.
void | setCompressFactor (unsigned phaseIdx, const Scalar &value)
Scalar | compressFactor (unsigned phaseIdx) const
template<class FluidState>
void | assign (const FluidState &fs)
| Retrieve all parameters from an arbitrary fluid state.
void | checkDefined () const
| Make sure that all attributes are defined.
const Scalar & | K (unsigned compIdx) const
void | setKvalue (unsigned compIdx, const Scalar &value)
| Set the K value of a component [-].
const Scalar & | L () const
| The L value of a composition [-].
void | setLvalue (const Scalar &value)
| Set the L value [-].
Scalar | wilsonK_ (unsigned compIdx) const
| Wilson formula to calculate K.

## Protected Member Functions

const Implementation & | asImp_ () const

## Protected Attributes

std::array< std::array< Scalar, numComponents >, numPhases > | moleFraction_ {}
std::array< Scalar, numPhases > | averageMolarMass_ {}
std::array< Scalar, numPhases > | sumMoleFractions_ {}
std::array< Scalar, numComponents > | totalModelFractions_ {}
std::array< Scalar, numPhases > | Z_ {}
std::array< Scalar, numComponents > | K_ {}
Scalar | L_ {}

## Detailed Description

template<class Scalar, class FluidSystem, class Implementation>
class Opm::FluidStateExplicitCompositionModule< Scalar, FluidSystem, Implementation >

Module for the modular fluid state which stores the phase compositions explicitly in terms of mole fractions.

## Member Function Documentation

## averageMolarMass()

template<class Scalar, class FluidSystem, class Implementation>

const Scalar & Opm::FluidStateExplicitCompositionModule< Scalar, FluidSystem, Implementation >::averageMolarMass | ( | unsigned | phaseIdx | ) | const

inline

The mean molar mass of a fluid phase [kg/mol].

The average molar mass is the mean mass of one mole of the fluid at current composition. It is defined as the sum of the component's molar masses weighted by the current mole fraction:

## checkDefined()

template<class Scalar, class FluidSystem, class Implementation>

void Opm::FluidStateExplicitCompositionModule< Scalar, FluidSystem, Implementation >::checkDefined | ( |  | ) | const

inline

Make sure that all attributes are defined.

This method does not do anything if the program is not run under valgrind. If it is, then valgrind will print an error message if some attributes of the object have not been properly defined.

## molarity()

template<class Scalar, class FluidSystem, class Implementation>

Scalar Opm::FluidStateExplicitCompositionModule< Scalar, FluidSystem, Implementation >::molarity | ( | unsigned | phaseIdx,
|  | unsigned | compIdx ) const

inline

The concentration of a component in a phase [mol/m^3].

This quantity is often called "molar concentration" or just "concentration", but there are many other (though less common) measures for concentration.

http://en.wikipedia.org/wiki/Concentration

The documentation for this class was generated from the following file:

- opm/material/fluidstates/FluidStateCompositionModules.hpp